#include "vector.h"
#include <iostream>

using namespace std;

Vector::Vector(int size)
{
	this -> size = size;
	this -> head = 0;
}

Vector::Vector(Vector &v2)
{
	size = v2.size;
	head = 0;
	Node *tmp = v2.head;
	Node *tmp2;
	while(tmp){ //Data added in opposite order
		tmp2 = new Node;
		tmp2->index = tmp->index;
		tmp2->data = tmp->data;
		tmp2->next = head;
		head = tmp2;
		tmp = tmp->next;
	}
}

Vector::~Vector()
{
	Node *tmp = head;
	while(tmp){
		head = tmp->next;
		delete(tmp);
		tmp = head;
	}
}

int Vector::get_size()
{
	return size;
}

void Vector::set_size(int newsize)
{
	size = newsize;
}

Node *find_element(int index, Node *head)
{
	while(head){
		if(head->index == index) return head;
		head = head->next;
	}
	return 0;
}

double Vector::read_element(int index)
{
	struct Node* tmp = find_element(index,head);
	if(tmp) return tmp->data;
	return 0;
}

void Vector::write_element(int index, double e)
{
	struct Node* tmp = find_element(index,head);
	if(tmp) tmp->data = e;
	else{
		tmp = new Node;
		tmp -> index = index;
		tmp -> data = e;
		tmp -> next = head;
		head = tmp;
	}
}

ostream& operator<<(ostream & o, Vector &v)
{
	for(int i=0; i<v.size; i++)
		o << v.read_element(i) << ", ";
	o << endl;
	return o;
}

Vector & Vector::operator=(Vector &v2)
{
	Node *tmp = head;
	Node *tmp2;
	while(tmp){
		head = tmp->next;
		delete(tmp);
		tmp = head;
	}
	size = v2.size;
	head = 0;
	tmp = v2.head;
	while(tmp){ //Data added in opposite order
		tmp2 = new Node;
		tmp2->index = tmp->index;
		tmp2->data = tmp->data;
		tmp2->next = head;
		head = tmp2;
		tmp = tmp->next;
	}
	return *this;
}

double & Vector::operator[](int index)
{
	Node *tmp = find_element(index,head);
	if(tmp) return tmp->data;
	tmp = new Node;
	tmp -> index = index;
	tmp -> data = 0;
	tmp -> next = head;
	head=tmp;
	return tmp->data;
}
